format PE GUI 4.0
include '%fasminc%\win32a.inc'

	; GetKernel procedure
	mov	eax, [fs:30h]			       ; ptr 2 
	test	eax, eax
	js	@F				       ; if we R on 9x - jmp @F

	mov	eax, [eax + 12] 		       ; ptr 2 PEB_LDR_DATA
	mov	esi, [eax + 28] 		       ; ptr 2 InitializationOrderModuleList
	lodsd
	mov	ebx, [eax + 8]			       ; eax -> VA kernel32.dll
	jmp	GetFunctions

  @@:	mov	eax, [eax + 52]
	mov	ebx, [eax + 184]

      GetFunctions:
	; Search for API
	mov	edx, [ebx + 3ch]		       ; PE
	mov	esi, [ebx + edx + 78h]		       ; Export Table RVA
	lea	esi, [ebx + esi + 18h]		       ; Export Table VA+18h
	lodsd
	xchg	eax, ecx			       ; NumberOfNames
	lodsd					       ; AddressOfFunctions
	push	eax
	lodsd					       ; AddressOfNames
	add	eax, ebx
	xchg	eax, edx
	lodsd					       ; AddressOfNameOrdinals
	add	eax, ebx
	push	eax
	mov	esi, edx

	mov	edi, HashTable

      search_api_name:
	lodsd
	add	eax, ebx			       ; eax points to the name of function
	; Calc function name hash
	xor	edx, edx			       ; edx == 0, coz it'll contain hash

      calc_hash:
	rol	edx, 3
	xor	dl, byte [eax]			       ; xor dl with current character
	inc	eax				       ; character shift
	cmp	byte [eax], 0			       ; is we in the end of chain?
	jnz	calc_hash
	; Get offset to ordinal
	mov	eax, [esp]			       ; AddressOfNameOrdinals
	add	dword [esp], 2			       ; Move to next ordinal word

      ok_hash:
	cmp	[edi], edx
	jnz	@F
		; Needed function found
		movzx	eax, word [eax] 	       ; Name ordinal
		shl	eax, 2			       ; Multiply by 4
		add	eax, [esp + 4]
		add	eax, ebx
		mov	eax, [eax]
		add	eax, ebx
		stosd
    @@: cmp	dword [edi], 0			       ; Skip function hash
	jnz	search_api_name
	add	esp, 8
	invoke	ExitProcess, 0

HashTable:		       ; Functions' hashes must be in alphabetical order
	CloseHandle	       dd 0C0D6D616h
	CreateFile	       dd 038C62A7Ah
	ExitProcess	       dd 0E6FF2CB9h
	GetFileSize	       dd 09554EFE7h
	GetModuleFileName      dd 060F43F1Bh
	GetModuleHandle        dd 0C9BFFA7Dh
	GetProcAddress	       dd 0F2509B84h
	GlobalAlloc	       dd 0C2F6D009h
	GlobalFree	       dd 0585ED3CFh
	IsDebuggerPresent      dd 09279E814h
	LoadLibrary	       dd 0A412FD89h
	ReadFile	       dd 00BE25545h
	VirtualProtect	       dd 0C5FF2F46h
	Zero		       db 0
			       ; Terminating NULL is necessary. DON'T DELETE